<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCabecDocERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCabecDocERP
 * @subpackage Arrays
 */
class ArrayOfCabecDocERP extends AbstractStructArrayBase
{
    /**
     * The CabecDocERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabecDocERP[]
     */
    public $CabecDocERP;
    /**
     * Constructor method for ArrayOfCabecDocERP
     * @uses ArrayOfCabecDocERP::setCabecDocERP()
     * @param \StructType\CabecDocERP[] $cabecDocERP
     */
    public function __construct(array $cabecDocERP = array())
    {
        $this
            ->setCabecDocERP($cabecDocERP);
    }
    /**
     * Get CabecDocERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabecDocERP[]|null
     */
    public function getCabecDocERP()
    {
        return isset($this->CabecDocERP) ? $this->CabecDocERP : null;
    }
    /**
     * Set CabecDocERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CabecDocERP[] $cabecDocERP
     * @return \ArrayType\ArrayOfCabecDocERP
     */
    public function setCabecDocERP(array $cabecDocERP = array())
    {
        foreach ($cabecDocERP as $arrayOfCabecDocERPCabecDocERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfCabecDocERPCabecDocERPItem instanceof \StructType\CabecDocERP) {
                throw new \InvalidArgumentException(sprintf('The CabecDocERP property can only contain items of \StructType\CabecDocERP, "%s" given', is_object($arrayOfCabecDocERPCabecDocERPItem) ? get_class($arrayOfCabecDocERPCabecDocERPItem) : gettype($arrayOfCabecDocERPCabecDocERPItem)), __LINE__);
            }
        }
        if (is_null($cabecDocERP) || (is_array($cabecDocERP) && empty($cabecDocERP))) {
            unset($this->CabecDocERP);
        } else {
            $this->CabecDocERP = $cabecDocERP;
        }
        return $this;
    }
    /**
     * Add item to CabecDocERP value
     * @throws \InvalidArgumentException
     * @param \StructType\CabecDocERP $item
     * @return \ArrayType\ArrayOfCabecDocERP
     */
    public function addToCabecDocERP(\StructType\CabecDocERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CabecDocERP) {
            throw new \InvalidArgumentException(sprintf('The CabecDocERP property can only contain items of \StructType\CabecDocERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CabecDocERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CabecDocERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CabecDocERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CabecDocERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CabecDocERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CabecDocERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CabecDocERP
     */
    public function getAttributeName()
    {
        return 'CabecDocERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCabecDocERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
